// Библиотека работы с пультом 315/433
#include <RCSwitch.h>
RCSwitch mySwitch = RCSwitch();

// Коды клавиш от двух пультов, с которых будет управлние
#define RC_CODE1 0x5C00
#define RC_CODE2 0x65B1


int ledPin = 3;    // Выход ШИМ на диммер
int powerPin = 9; // Управление драйвером через симистор
 
 
uint8_t pwmLevel = 255; 
boolean pwmStat  = false;
boolean pwmInc   = true;
 
uint32_t ms, ms1 = 0; 
boolean press_flag = false; 
uint16_t press_cnt = 0;
 
 
 
void setup()
{
    mySwitch.enableReceive(0);  
    pinMode(ledPin, OUTPUT);      
    pinMode(powerPin, OUTPUT);      
    digitalWrite(powerPin,LOW);
    Serial.begin(9600);
    delay(1000);
    Serial.println("Start");
}
 
 
void loop()
{    
    ms = millis();
// Принимаем коды с радиопульта
   if (mySwitch.available()) {
      int value = mySwitch.getReceivedValue();
      if( value == RC_CODE1 || value == RC_CODE2 ){
         press_flag = true;
      }
      mySwitch.resetAvailable();
   }
    
    
    
// Задержка 250мс для устранения дребезга
    if( ( ms - ms1 ) >200 || ms < ms1 ){  
// Если нажата клавиша      
       if( press_flag ){
          press_cnt++;
// Если лампа включена          
            if( pwmStat ){
// Инвертируем флаг уменьшения/увеличения              
             if( press_cnt == 5 ){
                pwmInc = !pwmInc;
             }//pres_cnt = 0
// Изменям значение диммера             
             else if( press_cnt > 5 ){   
                if( pwmInc ){
                   if( pwmLevel < 239 )pwmLevel+=16;
                   else pwmLevel = 255;
                }//pwmInc
                else        {
                   if( pwmLevel >80 )pwmLevel-=16;   
                   else pwmLevel = 64;
                }// else pwmInc
             }
             Serial.print("Mode=");
             Serial.print(pwmInc);
             Serial.print(" level=");
             Serial.print(pwmLevel);
             Serial.print(" count=");
             Serial.println(press_cnt);
             analogWrite(ledPin, pwmLevel);
        }
          
       }
       else {
// Короткое (менее 1 сек) нажатие клавиши         
          if( press_cnt > 0 && press_cnt < 5 ){
// Включение/отключение лампы            
             pwmStat = !pwmStat;
             if( pwmStat ) {
                  digitalWrite(powerPin,HIGH);
                  analogWrite(ledPin, pwmLevel);
             }
             else  {
                  analogWrite(ledPin, 0);
                  digitalWrite(powerPin,LOW);
             }
             Serial.print("Press=");
             Serial.print(pwmStat);
             Serial.print(" level=");
             Serial.print(pwmLevel);
             Serial.print(" count=");
             Serial.println(press_cnt);
         }

          press_cnt = 0;
       }
       ms1 = ms;
       press_flag = false;
    }  
}
